﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
	Public sqllib As SQL
End Sub
Public Sub Initialize(dbpath As String,dbfname As String, make As Boolean) As Boolean
	If File.Exists(dbpath,dbfname) = True Then
		sqllib.InitializeSQLite(dbpath,dbfname,make)
		Return True
	Else
		Return False
	End If
End Sub
Public Sub select_query(sql As String) As ResultSet
	Private rs As ResultSet = sqllib.ExecQuery(sql)
	Return rs
End Sub
Public Sub select_query_prepared(sql As String, values() As String) As ResultSet
	Private rs As ResultSet = sqllib.ExecQuery2(sql,values)
	Return rs
End Sub
Public Sub get_num_rows(table As String) As Int
	Private numrows As Int = sqllib.ExecQuerySingleResult("SELECT count(*) FROM " & table)
	Return numrows
End Sub
Public Sub table_exists(table As String) As Boolean
	Private rs As ResultSet = sqllib.ExecQuery2("SELECT name FROM sqlite_master WHERE type='table' AND name=?",Array As String(table))
	If rs.NextRow Then
		rs.Close
		Return True
	Else
		rs.Close
		Return False
	End If
End Sub
public Sub get_tablenames As List
	Dim lst As List
	lst.Initialize
	Private rs As ResultSet = sqllib.ExecQuery("SELECT name FROM sqlite_master WHERE type ='table' AND name NOT LIKE 'sqlite_%'")
	Do While rs.NextRow
		lst.Add(rs.GetString("name"))
	Loop
	rs.Close
	Return lst
End Sub
public Sub get_fieldnames(table As String) As List
	Dim lst As List
	lst.Initialize
	Private rs As ResultSet = sqllib.ExecQuery("PRAGMA table_info(" & table & ")")
	Do While rs.NextRow
		Dim rec As String = "[" & rs.GetString("name").Trim & "]"
		lst.Add(rec.Trim)
	Loop
	rs.Close
	Return lst
End Sub
public Sub get_fieldtypes(table As String) As List
	Dim lst As List
	lst.Initialize
	Private rs As ResultSet = sqllib.ExecQuery("PRAGMA table_info(" & table & ")")
	Do While rs.NextRow
		lst.Add(rs.GetString("type"))
	Loop
	rs.Close
	Return lst
End Sub
Public Sub get_structure(table As String) As List
	Dim lst As List
	lst.Initialize
	Private rs As ResultSet = sqllib.ExecQuery("PRAGMA table_info(" & table & ")")
	Do While rs.NextRow
		Dim rec As String
		rec = rs.GetString("cid") & "," & rs.GetString("name") & "," & rs.GetString("type") & "," & rs.GetString("pk")
		lst.Add(rec)
	Loop
	rs.Close
	Return lst
End Sub
public Sub get_records(table As String) As List
	Dim flst As List = get_fieldnames(table)
	'Log(flst)
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT * FROM " & table
	Private rs As ResultSet = select_query(sql)
	Do While rs.NextRow
		Dim rec As String
		For i = 0 To flst.Size -1
			Dim fld As String = flst.Get(i)
			If fld.Contains("[") Then
				fld = fld.SubString2(1,fld.Length-1)	' remove []
			End If
			Dim fldvalue As String
			If rs.GetString(fld) <> Null Then
				fldvalue = rs.GetString(fld)
			Else
				fldvalue = "NULL"
			End If
			If fldvalue.Contains(",") Then
				fldvalue = fldvalue.Replace(",","")		' comma is a delimiter
			End If
			fldvalue = fldvalue.Replace(Chr(13) & Chr(10),"")	' CRLF is record delimiter
			If i < flst.Size-1 Then
				rec = rec & fldvalue & ","
			Else
				rec = rec & fldvalue
			End If
		Next
		lst.Add(rec)
	Loop
	rs.Close
	Return lst
End Sub
Public Sub find_record(tablename As String, rowid As Int) As List
	Dim flst As List = get_fieldnames(tablename)
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT * FROM " & tablename & " WHERE rowid = ?"
	Private fldarr() As String = Array As String(rowid)
	Private rs As ResultSet = select_query_prepared(sql,fldarr)
	rs.NextRow
	Dim rec As String
	For i = 0 To flst.Size -1
		Dim fld As String = flst.Get(i)
		If fld.Contains("[") Then
			fld = fld.SubString2(1,fld.Length-1)	' remove []
		End If
		If i < flst.Size-1 Then
			rec = rec & rs.GetString(fld) & ","
		Else
			rec = rec & rs.GetString(fld)
		End If
	Next
	lst.Add(rec)
	rs.Close
	Return lst
End Sub
public Sub get_records_sorted(table As String,sfld As String) As List
	Dim flst As List = get_fieldnames(table)
	'Log(flst)
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT * FROM " & table & " ORDER BY " & sfld
	Private rs As ResultSet = select_query(sql)
	Do While rs.NextRow
		Dim rec As String
		For i = 0 To flst.Size -1
			Dim fld As String = flst.Get(i)
			If fld.Contains("[") Then
				fld = fld.SubString2(1,fld.Length-1)	' remove []
			End If
			Dim fldvalue As String
			If rs.GetString(fld) <> Null Then
				fldvalue = rs.GetString(fld)
			Else
				fldvalue = "NULL"
			End If
			If fldvalue.Contains(",") Then
				fldvalue = fldvalue.Replace(",","")		' comma is a delimiter
			End If
			fldvalue = fldvalue.Replace(Chr(13) & Chr(10),"")	' CRLF is record delimiter
			If i < flst.Size-1 Then
				rec = rec & fldvalue & ","
			Else
				rec = rec & fldvalue
			End If
		Next
		lst.Add(rec)
	Loop
	rs.Close
	Return lst
End Sub
